; example for the controller-board (www.frydaysoft.de)
;flash one Leds and put pressed KEY to LED
;poll the HCT245 and put this data to HCT574
;put text to LCD-display
;check RS232 and put received Bytes to LCD

$INCLUDE (C:\ide51\inc\mod51)

$INCLUDE (own_defs.INC)

;##################### MAIN Program #########################################

CSEG at 0
	;USING 3                 
	;USING 2                 
	;USING 1                 
	USING 0     	;Bank 0

ORG 0000h
JMP main_start		;jump to program

ORG 0003h               ;extInt0
RETI

ORG 000bh               ;timer0
RETI

ORG 0013h               ;extInt1
RETI

ORG 001Bh               ;timer1
RETI

ORG 0023h               ;RS232
RETI
;jmp SIO_INT

;**************************************************************************

main_start:
	MOV SP,  #Stack_First
	MOV DPTR,#0
	MOV ACC, #0
	MOV B,	 #0
	MOV PSW, #0
	MOV PCON,#0
	MOV SCON,#0
	MOV TCON,#0
	MOV TMOD,#0
	MOV IE,  #0
	MOV IP,  #0

	CLR step_walk
	SETB blick_cursor

	CALL lcd_init
	MOV DPTR,#LCD_TEXT		;alernative code
	SETB step_walk
	CALL lcdstring			;with defined const-string

	LCALL init_com         		;init V.24 at 9600 Baud
	MOV DPTR,#SIO_TEXT		;send text to RS232
	CALL send_const_text

	MOV P1,#0efh		;Led4 on
	MOV A,#0
	CALL setcursor
;call clearLCD		;clear LCD and cursor home
	CLR RI
	CLR TI

;################## Main - L O O P ########################

MainLoop:
	JB RI,read		;wenn Empfang ->clr RI+read SBUF
	SJMP check_ports
read:
	MOV A,SBUF		;read rs232-buffer
	CLR RI			;enable rs232-receive 
	; do something with received byte ....
	CLR TI                  ;Sendeinterupt clear
	MOV SBUF,A
	JNB TI,$
	CALL write_char		;write byte to LCD
	SJMP MainLoop

check_ports:
	MOV B,#HCT138_Y2	;read from HCT245
	CALL in_io
	CPL A
	MOV B,#HCT138_Y1	;write to HCT574
	CALL out_io
	CLR LED1		;set LED1,2,3 in case of KEY1,2,3
	JNB KEY1,ReadKey2
	SETB LED1
ReadKey2:
	CLR LED2
	JNB KEY2,ReadKey3	
	SETB LED2
ReadKey3:
	CLR LED3
	JNB KEY3,ReadKey4
	SETB LED3
ReadKey4:			
	JNB KEY4,call_wait	;stop toggle-mode if KEY4 is pressed
	JNB LED4,SetLed4	;toggle LED4		
	CLR LED4
	SJMP call_wait
SetLed4:
	SETB LED4	
call_wait:
	CALL wait		;wait a little time
        SJMP MainLoop           ;nothings to do

;****************************************************************
$INCLUDE (waitloop.INC)
$INCLUDE (io_port.INC)
$INCLUDE (lcd.INC)
$INCLUDE (sio.INC)

LCD_EMPTY:     DB '                ',ENDE
LCD_TEXT:      DB 'FrydaySoft c2002',ENDE
SIO_TEXT:      DB 13,10,13,10,'FrydaySoft c2002',13,10,13,10,ENDE

END